
; Edit the info header. CY = Error

Proc    Edit_Header
        push    ds
        pop     es

; *** Ask for Time ***
        mov     si,Offset Str4
        call    Str_Write
        movzx   eax,[Byte ds:_Time]     ; Write old value
        mov     cx,3
        call    _Write_Old
        mov     si,Offset Input_Str     ; Get value
        mov     cx,3
        call    Get_Input

        cmp     [Byte ds:Input_Str],0   ; No input?
        je      @@10                    ; Yes, use old
        mov     di,Offset Input_Str     ; Convert to binary
        call    ASCII_To_Bin
        jc      @@99
        mov     [Byte ds:_Time],al


; *** Ask for Dimonds to take ***
@@10:   mov     si,Offset Str5
        call    Str_Write
        movzx   eax,[Byte ds:_Dimond]   ; Write old value
        mov     cx,3
        call    _Write_Old
        mov     si,Offset Input_Str     ; Get value
        mov     cx,3
        call    Get_Input

        cmp     [Byte ds:Input_Str],0   ; No input?
        je      @@20                    ; Yes, use old
        mov     di,Offset Input_Str     ; Convert to binary
        call    ASCII_To_Bin
        jc      @@99
        mov     [Byte ds:_Dimond],al


; *** Ask for dimond score 1 ***
@@20:   mov     si,Offset Str6
        call    Str_Write
        movzx   eax,[Byte ds:_Dimond1]  ; Write old value
        mov     cx,3
        call    _Write_Old
        mov     si,Offset Input_Str     ; Get value
        mov     cx,3
        call    Get_Input

        cmp     [Byte ds:Input_Str],0   ; No input?
        je      @@30                    ; Yes, use old
        mov     di,Offset Input_Str     ; Convert to binary
        call    ASCII_To_Bin
        jc      @@99
        mov     [Byte ds:_Dimond1],al


; *** Ask for dimond score 2 ***
@@30:   mov     si,Offset Str7
        call    Str_Write
        movzx   eax,[Byte ds:_Dimond2]  ; Write old value
        mov     cx,3
        call    _Write_Old
        mov     si,Offset Input_Str     ; Get value
        mov     cx,3
        call    Get_Input

        cmp     [Byte ds:Input_Str],0   ; No input?
        je      @@40                    ; Yes, use old
        mov     di,Offset Input_Str     ; Convert to binary
        call    ASCII_To_Bin
        jc      @@99
        mov     [Byte ds:_Dimond2],al


; *** Ask for magic wall time ***
@@40:   mov     si,Offset Str8
        call    Str_Write
        movzx   eax,[Byte ds:_Magic]    ; Write old value
        mov     cx,3
        call    _Write_Old
        mov     si,Offset Input_Str     ; Get value
        mov     cx,3
        call    Get_Input

        cmp     [Byte ds:Input_Str],0   ; No input?
        je      @@50                    ; Yes, use old
        mov     di,Offset Input_Str     ; Convert to binary
        call    ASCII_To_Bin
        jc      @@99
        mov     [Byte ds:_Magic],al


; *** Ask for start X ***
@@50:   mov     si,Offset Str9
        call    Str_Write
        movzx   eax,[Byte ds:_StartH]   ; Write old value
        mov     cx,3
        call    _Write_Old
        mov     si,Offset Input_Str     ; Get value
        mov     cx,3
        call    Get_Input

        cmp     [Byte ds:Input_Str],0   ; No input?
        je      @@60                    ; Yes, use old
        mov     di,Offset Input_Str     ; Convert to binary
        call    ASCII_To_Bin
        jc      @@99
        mov     [Byte ds:_StartH],al


; *** Ask for start Y ***
@@60:   mov     si,Offset Str10
        call    Str_Write
        movzx   eax,[Byte ds:_StartV]   ; Write old value
        mov     cx,3
        call    _Write_Old
        mov     si,Offset Input_Str     ; Get value
        mov     cx,3
        call    Get_Input

        cmp     [Byte ds:Input_Str],0   ; No input?
        je      @@70                    ; Yes, use old
        mov     di,Offset Input_Str     ; Convert to binary
        call    ASCII_To_Bin
        jc      @@99
        mov     [Byte ds:_StartV],al


; *** Ask for Bonus life ***
@@70:   mov     si,Offset Str11
        call    Str_Write
        movzx   eax,[Byte ds:_Bonus]    ; Write old value
        mov     cx,1
        call    _Write_Old
        mov     si,Offset Input_Str     ; Get value
        mov     cx,1
        call    Get_Input

        cmp     [Byte ds:Input_Str],0   ; No input?
        je      @@80                    ; Yes, use old
        mov     di,Offset Input_Str     ; Convert to binary
        call    ASCII_To_Bin
        jc      @@99
        mov     [Byte ds:_Bonus],al


; *** Get level name ***
@@80:   mov     si,Offset Str12
        call    Str_Write
        mov     si,Offset Input_Str     ; Get value
        mov     cx,13
        call    Get_Input

        cmp     [Byte ds:Input_Str],0   ; No input?
        je      @@90                    ; Yes, use old
        mov     si,Offset Input_Str     ; Copy level name
        mov     di,Offset _Name
        mov     cx,13
@@85:   lodsb
        or      al,al
        jz      @@86
        stosb
        loop    @@85
@@86:   mov     al,' '                  ; Clear the rest
        rep     stosb

@@90:   clc
@@99:   ret
EndP    Edit_Header


; Write the old value (EAX = Value, CX = Digits)
Proc    _Write_Old
        mov     di,Offset Input_str     ; Convert to bin
        call    Bin_To_ASCII
        mov     [Byte ds:di],0          ; ASCIIZ

        mov     si,Offset Input_str     ; Write number
        call    Str_Write

        mov     si,Offset Str_End       ; Write end of string
        call    Str_Write

        ret
EndP    _Write_Old




; Copy header from file to buffer

Proc    Copy_Header
        mov     ax,[Word ds:Level_Seg]  ; ES = Level seg
        mov     es,ax
        mov     bx,[Word ds:Level_Num]
        add     bx,bx
        mov     dx,[Word es:4+bx]       ; AX = Para offset to current level
        mov     ax,[Word ds:Level_Seg]
        add     ax,dx
        mov     es,ax
        xor     di,di                   ; ES:DI = Where to copy

        mov     si,Offset _H
        mov     cx,23
@@Copy: mov     al,[Byte es:di]
        inc     di
        mov     [Byte ds:si],al
        inc     si
        loop    @@Copy

        ret
EndP    Copy_Header




; Setup a new level. CY = Error

Proc    New_Level

; Write new file message...
        call    New_Line
        mov     cx,1
        call    One_Param
        call    Str_Write
        mov     si,Offset File1_Str
        call    Str_Write
        call    New_Line


; Ask for input
        mov     si,Offset Str1          ; Ask for H size
        call    Str_Write
        mov     si,Offset Input_Str     ; Get H size
        mov     cx,3
        call    Get_Input
        cmp     [Byte ds:Input_Str],0   ; No input?
        je      @@Err
        mov     di,Offset Input_Str     ; Convert to binary
        call    ASCII_To_Bin
        jc      @@99
        mov     [Byte ds:_H],al

        mov     si,Offset Str2          ; Ask for V size
        call    Str_Write
        mov     si,Offset Input_Str     ; Get V size
        mov     cx,3
        call    Get_Input
        cmp     [Byte ds:Input_Str],0   ; No input?
        je      @@Err
        mov     di,Offset Input_Str     ; Convert to binary
        call    ASCII_To_Bin
        jc      @@99
        mov     [Byte ds:_V],al

        mov     si,Offset Str3          ; Ask for filler
        call    Str_Write
        mov     si,Offset Input_Str     ; Get V size
        mov     cx,1
        call    Get_Input
        cmp     [Byte ds:Input_Str],0   ; No input?
        je      @@Err
        mov     di,Offset Input_Str     ; Convert to binary
        call    ASCII_To_Bin
        jc      @@99
        mov     [Byte ds:Filler],al

        call    New_Line

; Make new level
        movzx   dx,[Byte ds:_V]         ; DX = V
        dec     dx
        dec     dx
        movzx   bp,[Byte ds:_H]         ; BP = H

        mov     ax,[Word ds:Level_Seg]
        mov     es,ax                   ; ES:DI = Level seg
        xor     di,di


; Clear slack space
        xor     al,al
        mov     cx,23+16
        rep     stosb
        xor     di,di


; Setup info header
        mov     [Dword es:di],'1-DB'    ; ID
        mov     [Word es:di+4],1        ; Setup pointer to level
        mov     [Word es:di+6],-1


; First line
        add     di,23+16                ; Skipp info headers
        mov     al,02h
        mov     cx,bp
        rep     stosb

; The middle lines
@@10:   mov     [Byte es:di],02h        ; Start wall
        inc     di
        mov     cx,bp
        dec     cx
        dec     cx
        mov     al,[Byte ds:Filler]
        rep     stosb                   ; The rest
        mov     [Byte es:di],02h        ; Start wall
        inc     di
        dec     dx
        jnz     @@10

; The last line
        mov     al,02h
        mov     cx,bp
        rep     stosb


; Calculate level size
        mov     al,[Byte ds:_V]
        mul     [Byte ds:_H]            ; AX = Map size
        mov     [Word ds:Map_Size],ax
        add     ax,23+16                ; Add headers
        mov     bl,al
        and     bl,1111b
        shr     ax,4                    ; Convert to para
        or      bl,bl                   ; Para aligned?
        jz      @@20
        inc     ax                      ; Add one para
@@20:   mov     [Word ds:File_Size],ax

        clc
@@99:   ret

@@Err:  stc
        ret
EndP    New_Level





; Copy the map we have edit to
; the level buffer

Proc    Copy_Level
        mov     ax,[Word ds:Level_Seg]  ; ES = Level seg
        mov     es,ax
        mov     bx,[Word ds:Level_Num]
        add     bx,bx
        mov     dx,[Word es:4+bx]       ; AX = Para offset to current level
        mov     ax,[Word ds:Level_Seg]
        add     ax,dx
        mov     es,ax
        xor     di,di                   ; ES:DI = Where to copy

        mov     si,Offset _H            ; Copy header
        mov     cx,23
        rep     movsb

; Copy level        
        mov     si,Offset Map           ; DS:SI = Level
        mov     cx,[Word ds:Map_Size]
        rep     movsb                   ; Copy level

        ret
EndP    Copy_Level









; Edit the map

Proc    Edit_Map
        mov     ax,03h                  ; Get mouse position
        int     33h
        and     bl,00000111b
        or      bl,bl                   ; Skipp if no buttons is down
        jz      @@99
        push    bx                      ; Save button status
        push    dx                      ; Save Y


; Find screen position
        mov     si,Offset Map

        mov     al,[Byte ds:Pos_V]
        mul     [Byte ds:Map_H]         ; in map
        add     al,[Byte ds:Pos_H]
        adc     ah,0
        add     si,ax                   ; SI = Left corner


; Find mouse position        
        mov     ax,cx                   ; CX = X
        shl     ax,6
        xor     dx,dx                   ; AX:DX = X cordinate * 64
        mov     bx,114*12
        div     bx                      ; AX = X cordinate (0 - 29)
        mov     bp,ax

        pop     ax                      ; Restore Y
        shl     ax,6
        xor     dx,dx                   ; AX:DX = Y cordinate * 64
        mov     bx,57*12
        div     bx                      ; AX = Y cordinate (0 - 19)

        mul     [Byte ds:Map_H]         ; Find vertical
        add     ax,bp                   ; Add horizontal
        add     si,ax                   ; SI = Position to use


; Find out witch button is down?
        pop     ax                      ; AL = Button status
        test    al,0001b                ; Left button?
        jz      @@10
        movzx   bx,[Byte ds:Draw_Type]  ; Yes, get current icon
        mov     ah,[Byte ds:Type_Table+bx]
        jmp     @@80

@@10:   test    al,0010b                ; Right button?
        jz      @@20
        xor     ah,ah                   ; Yes, clear position
        jmp     @@80

@@20:   mov     ah,1                    ; Must be middle button (Unexplored)
        

@@80:   mov     [Byte ds:si],ah         ; Write new icon
@@99:   ret
EndP    Edit_Map





; Get and handle the keys

Proc    Get_Key

; *** Do the scrolling ***
        cmp     [Byte ds:Key_Map+4Dh],0         ; Right?
        je      @@05
        
        mov     al,[Byte ds:Map_H]
        sub     al,[Byte ds:Pos_H]
        cmp     al,30
        jbe     @@10

        inc     [Byte ds:Pos_H]                 ; Increase horizontal
        jmp     @@10


@@05:   cmp     [Byte ds:Key_Map+4Bh],0         ; Left?
        je      @@10
        cmp     [Byte ds:Pos_H],0
        je      @@10

        dec     [Byte ds:Pos_H]                 ; Decrease horizontal

@@10:   cmp     [Byte ds:Key_Map+50h],0         ; Down?
        je      @@15
        mov     al,[Byte ds:Map_V]
        sub     al,[Byte ds:Pos_V]
        cmp     al,19
        jbe     @@20

        inc     [Byte ds:Pos_V]                 ; Increase vertical
        jmp     @@20

@@15:   cmp     [Byte ds:Key_Map+48h],0         ; Up?
        je      @@20
        cmp     [Byte ds:Pos_V],0
        je      @@20

        dec     [Byte ds:Pos_V]                 ; Decrease vertical



; *** Do some other stuff ***
@@20:

@@99:   ret
EndP    Get_Key







;     *** Edit the level ***

; In:   [Level_Seg] = Level
;
; Out:  AL = -1 --> Not our level
;          = -2 --> Shame!
;
; Regs: ALL!

Proc    Edit_Level
        mov     ax,[Word ds:Level_Seg]  ; Get segment to game
        mov     es,ax
        xor     si,si
        mov     al,-2
        cmp     [Dword es:si],'X-DB'    ; Is it my level?
        je      @@99

@@00:   mov     al,-1
        cmp     [Dword es:si],'1-DB'    ; Our level?
        jne     @@99
        add     si,4                    ; Level table

        mov     bx,[Word ds:Level_Num]
        add     bx,bx
        mov     ax,[Word es:si+bx]      ; Get segment to level

@@10:   add     ax,[Word ds:Level_Seg]
        call    _Edit                   ; AX = Level to edit

@@99:   ret

EndP    Edit_Level






; Internal...

; In:   AX = Level to play
;
; Out:  Nothing
;
; Regs: All - SI,ES

Proc    _Edit
        push    es si

; ES:SI = Level to edit
        mov     es,ax
        xor     si,si


; Setup level data
        mov     al,[Byte es:si]         ; H
        mov     [Byte ds:Map_H],al
        mov     bl,[Byte es:si+1]       ; V
        mov     [Byte ds:Map_V],bl
        mul     bl                      ; AX = H * V
        mov     [Word ds:Map_Size],ax


; Copy Level to map
        mov     cx,ax                   ; CX = Map size
        shr     cx,2                    ; Convert to Dword
        inc     cx                      ; One extra
        mov     si,23
        mov     di,Offset Map
@@10:   mov     eax,[Dword es:si]
        mov     [Dword ds:di],eax
        add     si,4
        add     di,4
        dec     cx
        jnz     @@10



;============================================================================
 Main_Loop:
;============================================================================
        cmp     [Byte ds:Update],0      ; Sync with timer interupt
        jz      Main_Loop
        dec     [Byte ds:Update]

        call    Get_Key
        call    Edit_Map


; *** Draw screen ***
        mov     ax,0A000h               ; ES = Screen again
        mov     es,ax

@@Draw: mov     bp,offset Map
        mov     di,Page_1               ; Do the page flipping
        cmp     [Byte ds:Curr_Page],1
        je      @@20
        mov     di,Page_2

@@20:   push    di
        call    Draw_Screen             ; Changes DS
        pop     bx

        sub     bx,X_Byte*12
        call    Write_SA                ; Flipp page
        xor     [Byte gs:Curr_Page],1   ; Next page

        xor     bl,bl                   ; Set normal write mode
        call    Set_W_Mode
        mov     ax,Data_Seg
        mov     ds,ax


; Check if we are finished
        xor     ah,ah

        mov     al,1                    ; ESC pressed?
        cmp     [Byte ds:ESC_Flagg],0
        je      Main_Loop

@@99:   pop     si es
        ret
;============================================================================
EndP    _Edit
